freeslot("MT_HUGMETEOR", "sfx_hgstb", "sfx_hugfly", "sfx_hugnit", "sfx_hsqsh", "sfx_jspr", "S_HUGGERTBULLET3", "S_HUGSTARNORMAL3", "sfx_hgsrd", "SPR_HTHK", "MT_HUGGERTBULLET", "S_HUGGERT_FIRE", "S_HUGGERTFLY", "sfx_hgtslp", "MT_HUGGERTSSTAR", "sfx_hgspf", "sfx_hgsbn", "sfx_hgsth", "sfx_hgsmk", "MT_HUGGERTSSTARPART")
states[S_HUGGERTFLY] = {SPR_PLAY, SPR2_LAND, TICRATE, nil, 0, 0, S_HUGGERTFLY}
states[S_HUGGERT_FIRE] = {SPR_PLAY, SPR2_ROLL|FF_ANIMATE, 16, nil, 4, 2, S_PLAY_JUMP}
sfxinfo[sfx_hgtslp].caption = "Snore"
sfxinfo[sfx_hgspf].caption = "/"
sfxinfo[sfx_hgsbn].caption = "Star bouncing"
sfxinfo[sfx_hgsth].caption = "Thrown star"
sfxinfo[sfx_hgstb].caption = "Shooting star"
sfxinfo[sfx_jspr].caption = "Thrown star"
sfxinfo[sfx_hgsmk].caption = "Creating a star"
sfxinfo[sfx_hgsrd].caption = "Max Charge"
sfxinfo[sfx_hsqsh].caption = "Squish"
sfxinfo[sfx_hugnit].caption = "Star Boost"
sfxinfo[sfx_hugfly].caption = "/"

addHook("PlayerSpawn", function(player)
	player.didntsnore = 0
	player.clouddown = 0
	player.hughovercheck = false
	player.hughovertimer = TICRATE
	player.hugjump = 0
	player.starcharger = 0
	player.starcooldown = 0
	player.starchargeready = false
	player.starnum = 0 
	player.upfireboost = false
	player.firefuel = 40
	player.startype = MT_HUGGERTBULLET
	player.croucher = false
	player.squasheffect = 0
	if player.mo and player.mo.skin == "huggert" then player.charflags = skins["huggert"].flags end
end)

-- Quick cvar for debug purposes
rawset(_G, "cv_huggertchargedamage", CV_RegisterVar({
    name = 'huggert_chargedamage',
    defaultvalue = 2,
    flags = CV_NETVAR|CV_CHEAT|CV_NOSHOWHELP|CV_CALL,
    func = function(value)
        if value.value ~= 2
            G_SetUsedCheats()
        end
    end,
    PossibleValue = {MIN = 1, MAX = 4},
}))

local function P_CheckAndCrumble(mo) -- let the object find a wall/floor to fuck up
    local rad = mo.radius + mo.scale*15
    for x = mo.x - rad, mo.x + rad, rad do
        for y = mo.y - rad, mo.y + rad, rad do
            local subsec = R_PointInSubsectorOrNil(x,y)
            if not subsec then continue end
            local sec = subsec.sector
            for rover in sec.ffloors() do
                if (rover.flags & (FF_EXISTS|FF_BUSTUP)) ~= (FF_EXISTS|FF_BUSTUP) then continue end
                if (mo.z > rover.topheight) or (mo.z + mo.height < rover.bottomheight) then continue end
                EV_CrumbleChain(sec, rover)
            end
        end
    end
end

addHook("PlayerThink", function(player)
	if not (player.mo and player.mo.valid) return end
	if player.hughovercheck == nil -- because god forbid you didnt spawn as huggert
		player.didntsnore = 0
		player.clouddown = 0
		player.hughovercheck = false
		player.hughovertimer = TICRATE
		player.hugjump = 0
		player.starcharger = 0
		player.starcooldown = 0
		player.starchargeready = false
		player.startype = MT_HUGGERTBULLET
		player.jaspermode = false
		player.huggertAimCommand = 1
	end
	
	if (player.mo.skin != "huggert") 
		player.timerforsleep = 0 
		if player.croucher
			player.squasheffect = 0
			player.mo.spritexscale = FRACUNIT
			player.mo.spriteyscale = FRACUNIT
			player.croucher = false
		end
	end
	if not (player.mo and player.mo.skin == "huggert") return end
	if player.powers[pw_carry] == CR_MINECART then return end
	
	if player.fanobj == nil
    or (P_PlayerInPain(player)) 
    or player.mo.state == S_PLAY_PAIN or player.mo.state == S_PLAY_DEAD or player.mo.state == S_PLAY_ROLL
    or player.powers[pw_carry]
    or P_IsObjectOnGround(player.mo) or player.mo.eflags & MFE_JUSTHITFLOOR
        player.fanobj = false
    end
	
	if (player.mo.state == S_PLAY_SUPER_TRANS1 or player.mo.state == S_PLAY_HYPERTRNS_1) -- fuck this
		player.pflags = $1|PF_THOKKED
		player.pflags = $1 & ~PF_JUMPED
	end

	//we sleep....
	if player.mo.state == S_PLAY_WAIT and not S_SoundPlaying(player.mo, sfx_hgtslp)
		if player.didntsnore == nil then player.didntsnore = 0 end
		if (player.mo.frame & FF_FRAMEMASK) == E and player.didntsnore == 0
			player.didntsnore = 1
			S_StartSound(player.mo, sfx_hgtslp)
			local zs = P_SpawnMobjFromMobj(player.mo, 0,0,50*player.mo.scale, MT_HGTSLEEP)
			zs.scale = $*(3/2)
			zs.destscale = $/4
			zs.angle = FixedAngle(P_RandomRange(0,359)*FRACUNIT)
			P_Thrust(zs, zs.angle, FRACUNIT)
			zs.scalespeed = FRACUNIT/40
			zs.momz = FRACUNIT*P_MobjFlip(player.mo)
		end
		if (player.mo.frame & FF_FRAMEMASK) != E then player.didntsnore = 0 end
	end
	
	if player.clouddown == nil then player.clouddown = 0 end
	if player.clouddown > 0 then player.clouddown = $-1 end
	
	
	if player.mo.health 
	and not (P_PlayerInPain(player))
	and not (player.mo.eflags & MFE_SPRUNG)
	and not player.powers[pw_justsprung] 
	and not player.powers[pw_noautobrake]
	and not player.powers[pw_carry]
	and not P_IsObjectOnGround(player.mo)
	and player.mo.state != S_PLAY_SPRING
	and player.mo.state != S_PLAY_JUMP
	and player.mo.state != S_PLAY_RIDE
	and not player.hughovercheck
	and not (player.powers[pw_carry] == CR_NIGHTSMODE)
	and not (player.pflags & PF_THOKKED)
		player.mo.momz = $ - P_GetMobjGravity(player.mo)*4/12 -- slightly lower gravity, why not? you're space themed after all.
		//welcome to particle hell
		player.quickRNG = P_RandomRange(2, 8)
		for i = 0,player.quickRNG
			local sparkstrail = P_SpawnMobjFromMobj(player.mo, (P_RandomRange(-10,10)*player.mo.scale),(P_RandomRange(-10,10)*player.mo.scale),(P_RandomRange(-10,0)*player.mo.scale), MT_BOXSPARKLE)
			sparkstrail.scale = $*(1/P_RandomRange(1, 3))
			sparkstrail.color = player.mo.color
			sparkstrail.colorized = true
			sparkstrail.momx = P_RandomRange(-1, 1)*player.mo.scale
			sparkstrail.momy = P_RandomRange(-1, 1)*player.mo.scale
			sparkstrail.destscale = 0
			sparkstrail.scalespeed = player.mo.scale/12
			sparkstrail.fuse = TICRATE/2
			sparkstrail.frame = $|FF_FULLBRIGHT
		end
		
		if (player.quickRNG % 3 == 0)
			if P_RandomRange(0, 1)
				player.spawnobjforfalls = MT_HPARTICLES2
			else
				player.spawnobjforfalls = MT_HPARTICLES
			end
			local partcles = P_SpawnMobjFromMobj(player.mo, (P_RandomRange(-10,10)*player.mo.scale),(P_RandomRange(-10,10)*player.mo.scale),(P_RandomRange(-10,0)*player.mo.scale), player.spawnobjforfalls)
			partcles.color = ColorOpposite(player.mo.color)
			partcles.scale = $/2
			partcles.frame = $|FF_FULLBRIGHT
		end
	end
	
	if player.mo.state == S_PLAY_RUN -- run fx
		local sparkstrail = P_SpawnMobjFromMobj(player.mo, (P_RandomRange(-10,10)*player.mo.scale),(P_RandomRange(-10,10)*player.mo.scale),(-player.mo.height/2)*player.mo.scale, MT_BOXSPARKLE)
		sparkstrail.color = player.mo.color
		sparkstrail.colorized = true
		sparkstrail.destscale = 0
		sparkstrail.scalespeed = player.mo.scale/10
		sparkstrail.fuse = TICRATE/2
		sparkstrail.frame = $|FF_FULLBRIGHT
		P_SetObjectMomZ(sparkstrail, 5*FRACUNIT)
		
		if leveltime % 8 == 0
			local sta = P_SpawnMobjFromMobj(player.mo, (P_RandomRange(-10,10)*player.mo.scale),(P_RandomRange(-10,10)*player.mo.scale),(-player.mo.height/2)*player.mo.scale, MT_HUGGERTSSTARPART)
			sta.color = ColorOpposite(player.mo.color)
			sta.destscale = 0
			sta.scalespeed = player.mo.scale/10
			sta.frame = $|FF_FULLBRIGHT
			P_SetObjectMomZ(sta, 7*FRACUNIT)
		end
	end
		
	if (player.powers[pw_carry] == CR_NIGHTSMODE) -- nights fx to really seal the deal
		if S_SoundPlaying(player.mo, sfx_drill1) then S_StopSoundByID(player.mo, sfx_drill1) end
		if S_SoundPlaying(player.mo, sfx_drill2) then S_StopSoundByID(player.mo, sfx_drill2) end
		if (leveltime % 10 == 0 or not S_SoundPlaying(player.mo, sfx_hugnit)) and player.mo.state == S_PLAY_NIGHTS_DRILL then S_StartSound(player.mo, sfx_hugnit) end
		if player.mo.state == S_PLAY_NIGHTS_FLY and leveltime % (7 + (1/2)) == 0 then S_StartSound(player.mo, sfx_hugfly) end
	end
	if player.mo.state == S_PLAY_NIGHTS_DRILL
	or player.mo.state == S_PLAY_NIGHTS_FLY
		local timebreak = 1
		if player.mo.state == S_PLAY_NIGHTS_FLY then timebreak = 2 end
		if (leveltime % timebreak == 0)
			local st = P_SpawnMobj(player.mo.x+(P_RandomRange(-24, 24)*player.mo.scale), player.mo.y+(P_RandomRange(-24, 24)*player.mo.scale), player.mo.z+(P_RandomRange(-25, -10)*player.mo.scale), MT_HUGGERTSSTARPART)
			st.scale = player.mo.scale*P_RandomRange(1, 2)
			if P_RandomRange(0, 1) == 1 and player.mo.state != S_PLAY_NIGHTS_FLY
				st.color = SKINCOLOR_VAPOR
			else st.color = SKINCOLOR_FREEZERFOLLEY end
			st.momx = (player.mo.momx/2) + P_RandomRange(-5, 9)*player.mo.scale
			st.momy = (player.mo.momy/2) + P_RandomRange(-5, 9)*player.mo.scale
			st.momz = player.mo.momz + P_RandomRange(-2, 1)*player.mo.scale
		end
	end 
	
	//if you're gonna be sleeping for that long, have some music to go with it
	if player.timerforsleep == nil then  player.timerforsleep = 0 end
	if player.pirhanaplantmusic == 1
	and not srb2p 
		if player.mo.state == S_PLAY_WAIT
		and player.timerforsleep <= 35*TICRATE
			player.timerforsleep = $+1
			if player.timerforsleep == 35*TICRATE then S_ChangeMusic("FSLEEP", true, player, 0,0,35*TICRATE) end
		end
	end
		
	if (P_PlayerInPain(player))
	or not P_IsObjectOnGround(player.mo)
	or player.powers[pw_invulnerability]
	or player.powers[pw_sneakers]
	or player.powers[pw_carry]
	or player.powers[pw_super]
	or player.mo.state != S_PLAY_WAIT
	or player.timerforsleep == nil
	or player.pirhanaplantmusic == 2
	or not player.mo.health
		if player.timerforsleep >= 35*TICRATE then COM_BufInsertText(player, "tunes \"-default\"") end
		player.timerforsleep = 0
	end
	
	// ----------------------------------------------------------------------
	
	//alright now for everything else
	if not (player.cmd.buttons & BT_JUMP)
		player.canhugjumpd = true
		player.hugjumpd = false
	elseif player.canhugjumpd 
		player.hugjumpd = true
		player.canhugjumpd = false
	else player.hugjumpd = false end
	
	
	if player.hughovercheck == nil
	or P_IsObjectOnGround(player.mo) or (player.mo.eflags & MFE_JUSTHITFLOOR)
	or (P_PlayerInPain(player))
	or player.mo.state == S_PLAY_PAIN
	or player.powers[pw_carry] and not (player.powers[pw_carry] == CR_NIGHTSMODE)
		if player.hughovercheck
			for i = 1, 6
				local d = P_SpawnMobjFromMobj(player.mo, 0,0,0, MT_HGTCLOUDS)
				d.scale = $*(3/2)
				d.angle = i*ANG60 + player.mo.angle
				P_Thrust(d, d.angle, 5*player.mo.scale)
				d.destscale = 0
				d.scalespeed = player.mo.scale/50
				d.momx = $+player.mo.momx
				d.momy = $+player.mo.momy
				d.momz = player.mo.momz
				P_SetObjectMomZ(d, 5*FRACUNIT)
			end
			S_StartSound(player.mo, sfx_s3k6d)
			player.charflags = skins["huggert"].flags
		end
		
		player.clouddown = 0
		player.hughovercheck = false
		player.hughovertimer = TICRATE
		player.hugjump = 0
	end
	
	if player.hugjumpd and player.hugjump != 2 and (player.pflags & PF_JUMPED) then player.hugjump = $ + 1 end
	if (player.mo.eflags & MFE_SPRUNG) and not (player.pflags & PF_JUMPED)
		player.clouddown = -1 
		player.hughovercheck = false
	end
	
	if (player.cmd.buttons & BT_JUMP) -- the hover ability
	and not (P_PlayerInPain(player))
	and not player.powers[pw_carry]
	and not P_IsObjectOnGround(player.mo)
	and player.hugjump > 1
	and not (player.mo.state == S_PLAY_DEAD)
	and player.clouddown == 0
	and not (player.gotflag or player.gotcrystal)
	and not (tracer and tracer.type == MT_TUBEWAYPOINT)
	and player.mo.health 
	and not (player.powers[pw_carry] == CR_NIGHTSMODE)
	and not (player.pflags & PF_THOKKED)
	and not player.FavCurrentFucker3000
	and not (CBW_Battle and player.actionstate != 0)
	and not srb2p
		if (CBW_Battle and player.tumble)
		or (CBW_Battle and player.airdodge) return end
		if player.mo.state != S_HUGGERTFLY then 
			player.mo.state = S_HUGGERTFLY 
			
			if not player.powers[pw_super] -- because charging interruption SUCKS, i'm tossing this here
				player.mo.color = player.skincolor
			else player.mo.color = player.mo.color end
			player.mo.colorized = false
			
			for i = 1, 6
				local d = P_SpawnMobjFromMobj(player.mo, 0,0,0, MT_HGTCLOUDS)
				d.scale = $*(3/2)
				d.angle = i*ANG60 + player.mo.angle
				P_Thrust(d, d.angle, 5*player.mo.scale)
				d.destscale = $/4
				d.scalespeed = player.mo.scale/40
				d.momx = $+player.mo.momx
				d.momy = $+player.mo.momy
				d.momz = player.mo.momz
			end
			S_StartSound(player.mo, sfx_s227)
			S_StartSound(player.mo, sfx_s3k4b)
		end
		
		player.hughovercheck = true
		player.starcharger = 0
		player.starchargeready = false
		player.pflags = $1 & ~PF_JUMPED 
		player.pflags = $1 & ~PF_SPINNING
		
		if not S_SoundPlaying(player.mo, sfx_frwind)
			S_StartSoundAtVolume(player.mo, sfx_frwind, 25)
		end
		-- particle hell
		if (leveltime % 8 == 0)
			for i = 0,P_RandomRange(1, 2)
				player.randomLOL = P_RandomRange(0, 5)
				local spaceparticle = P_SpawnMobjFromMobj(player.mo, (P_RandomRange(-32,32)*player.mo.scale),(P_RandomRange(-32,32)*player.mo.scale),(P_RandomRange(-30,-5)*player.mo.scale), MT_HGTFLY)
				if player.randomLOL <= 1
					if player.randomLOL == 0 
						spaceparticle.color = player.mo.color
					else spaceparticle.color = ColorOpposite(player.mo.color) end
					spaceparticle.colorized = true
				end
				spaceparticle.scale = $*(P_RandomRange(1, 3)/2)
				spaceparticle.frame = P_RandomRange(0, 6)
				spaceparticle.momx = P_RandomRange(-1, 1)*player.mo.scale
				spaceparticle.momy = P_RandomRange(-1, 1)*player.mo.scale
				spaceparticle.destscale = 0
				spaceparticle.scalespeed = player.mo.scale/40
			end
		end
		if (leveltime % 4 == 0)
			for i = 0, 2
				local clounds = P_SpawnMobjFromMobj(player.mo, (P_RandomRange(-32,32)*player.mo.scale),(P_RandomRange(-32,32)*player.mo.scale),(P_RandomRange(-30,-5)*player.mo.scale), MT_HGTFLY)
				clounds.frame = P_RandomRange(7, 16)|TR_TRANS20
				clounds.momx = P_RandomRange(-1, 1)*player.mo.scale
				clounds.momy = P_RandomRange(-1, 1)*player.mo.scale
				clounds.scale = $*(P_RandomRange(3, 4)/2)
				clounds.destscale = 0
				clounds.scalespeed = player.mo.scale/26
			end
		end 
		
		if player.hughovertimer != 0 -- this is it!!!! this is the hover part!!!!!!!!!!
			if not (player.mo.momz/P_MobjFlip(player.mo) >= 5*player.mo.scale)
				P_SetObjectMomZ(player.mo, 1*FRACUNIT, true)
			else P_SetObjectMomZ(player.mo, 6*FRACUNIT) end
			
			if player.mo.momz/P_MobjFlip(player.mo) >= 0 and not (player.powers[pw_super]) then player.hughovertimer = $-1 end
		else
			player.mo.momz = $ - (P_GetMobjGravity(player.mo)*5/7)
			player.charflags = SF_SUPER|SF_NOSHIELDABILITY|SF_NOJUMPSPIN|SF_NOJUMPDAMAGE
		end
	end
	
	if S_SoundPlaying(player.mo, sfx_frwind) and not (player.mo.state == S_HUGGERTFLY) then S_StopSoundByID(player.mo, sfx_frwind) end
	
	//Let go of yump..
	if not (player.cmd.buttons & BT_JUMP) and player.hughovercheck 
	and not (P_PlayerInPain(player)) and player.mo.health
	and not (player.mo.state == S_PLAY_DEAD)
	and player.clouddown != -1
	and player.playerstate == PST_LIVE
	or ((player.gotflag or player.gotcrystal)) and player.hughovercheck and player.clouddown != -1 and player.playerstate == PST_LIVE
		for i = 1, 6
			local d = P_SpawnMobjFromMobj(player.mo, 0,0,0, MT_HGTCLOUDS)
			d.scale = $*(3/2)
			d.angle = i*ANG60 + player.mo.angle
			P_Thrust(d, d.angle, 5*player.mo.scale)
			d.destscale = $/5
			d.scalespeed = player.mo.scale/40
			d.momx = $+player.mo.momx
			d.momy = $+player.mo.momy
			d.momz = player.mo.momz
		end
		player.charflags = skins["huggert"].flags
		S_StartSound(player.mo, sfx_s3k6d)
		player.clouddown = TICRATE/2
		player.mo.state = S_PLAY_JUMP
		player.hughovercheck = false
		if not (player.powers[pw_super]) then player.hughovertimer = 0 end
	end
	
	// -----------------------------------------------------------------------------------------
	if player.powers[pw_spacetime] == 400
		player.powers[pw_spacetime] = 1000 --he's space related, let him breathe longer.
	elseif player.powers[pw_spacetime] == 405
		player.powers[pw_spacetime] = 399
	end
	if player.powers[pw_spacetime] > 400 and player.powers[pw_spacetime] != 1000 -- notifyer
	and player.powers[pw_spacetime] % 200 == 0
		S_StartSound(player.mo, sfx_wtrdng)
	end	
	// -------------------------------------------------------------------------	
	// Welcome to the spin ability!
	if not (player.cmd.buttons & BT_SPIN)
		player.canspintap = true
		player.spintaphug = false
	elseif player.canspintap 
		player.spintaphug = true
		player.canspintap = false
	else player.spintaphug = false end
	
	if (player.cmd.buttons & BT_SPIN) and player.starcooldown == 0 and player.mo.state != S_HUGGERTFLY
	and not (P_PlayerInPain(player)) and player.playerstate == PST_LIVE
	and player.mo.health
	and not (player.mo.state == S_PLAY_ROLL or player.mo.state == S_PLAY_SPINDASH)
	and not player.powers[pw_carry]
	and not (player.pflags & PF_THOKKED)
	and not (player.pflags & PF_SPINNING)
	and not (player.pflags & PF_FULLSTASIS)
	and not (CBW_Battle and CBW_Battle.PreRoundWait())
	and not srb2p
	and not (CBW_Battle and player.actionstate > 0)
	and ((player.powers[pw_shield] & SH_NOSTACK) != SH_FLAMEAURA or (player.powers[pw_shield] & SH_NOSTACK) == SH_FLAMEAURA and (CBW_Battle and CBW_Battle.BattleGametype()))
		if (CBW_Battle and player.tumble)
		or (CBW_Battle and player.airdodge) return end
		//Here's the charge up!
		
		if player.starcharger != TICRATE/(3/2) and not player.spintaphug
			player.starcharger = $+1
			if not S_SoundPlaying(player.mo, sfx_hgsmk)
				S_StartSound(player.mo, sfx_hgsmk)
			end
		end
		if (leveltime % 2 == 0)
			for i = 0,(player.starcharger/18)
				local st = P_SpawnMobjFromMobj(player.mo, P_RandomRange(-65, 65)*player.mo.scale, P_RandomRange(-65, 65)*player.mo.scale, P_RandomRange(-35, 50)*player.mo.scale, MT_HUGGERTSSTARPART)
				st.target = player.mo
				st.blendmode = AST_ADD
				st.scale = $*P_RandomRange(1, 4)/P_RandomRange(2, 4)
				st.destscale = 0
				st.scalespeed = FRACUNIT/23 
				st.color = ColorOpposite(player.mo.color)
				if (leveltime % 4 == 0) then st.color = P_RandomRange(71, 105) end // a full on rainbow effect that grabs ALL colors!!
			end
		end
	end
	if player.mo.state == S_HUGGERTFLY then player.starcharger = 0 end
	
	if S_SoundPlaying(player.mo, sfx_hgsmk) and player.starcharger == 0
		if CBW_Battle and player.actionstate != 0 return end
		S_StopSoundByID(player.mo, sfx_hgsmk)
	end
	
	if player.starchargeready == nil then player.starchargeready = false end
	
	if (player.starcharger or player.starchargeready)
	and CBW_Battle and CBW_Battle.BattleGametype()
		CBW_Battle.DrawAimLine(player,player.mo.angle)
	end
	
	--flashy effects
	if player.starcharger == TICRATE/(3/2)
	and player.mo.health
		player.starchargeready = true
		if leveltime % 7 == 0 then S_StartSound(player.mo, sfx_hgsrd) end
		if leveltime % 4 == 0
			if player.mo.color == SKINCOLOR_PASTEL then player.mo.color = SKINCOLOR_COBALT
			else player.mo.color = SKINCOLOR_PASTEL end
			player.mo.colorized = true
		else
			if not player.powers[pw_super] 
				player.mo.color = player.skincolor
			else
				player.mo.color = player.mo.color
			end
			player.mo.colorized = false
		end
	end
	if not (player.starchargeready) and (player.mo.color == SKINCOLOR_NIGHTDREAMER or player.mo.color == SKINCOLOR_PASTEL) and player.mo.colorized
		player.mo.color = player.skincolor
		player.mo.colorized = false
	end
	if P_PlayerInPain(player) or player.powers[pw_carry] == CR_ROLLOUT or (CBW_Battle and player.guard != 0)
		player.starcharger = 0
		player.starchargeready = false
		if player.starcooldown <= 2 then player.starcooldown = 2 end
	end

	// Aiming!!
	if not P_IsObjectOnGround(player.mo) and player.cmd.forwardmove == 0 and player.cmd.sidemove == 0 and player.huggertAimCommand == 1
	or not P_IsObjectOnGround(player.mo) and (player.cmd.forwardmove != 0 or player.cmd.sidemove != 0) and player.huggertAimCommand == 2
	or not P_IsObjectOnGround(player.mo) and player.huggertAimCommand == 3
		if player.powers[pw_carry] == CR_ROLLOUT or (player.gotflag or player.gotcrystal) then player.aimdown = false end
		player.aimdown = true
	else
		player.aimdown = false
	end
	if player.huggertAimCommand == 4 or player.powers[pw_carry] == CR_ROLLOUT or (player.gotflag or player.gotcrystal) then player.aimdown = false end --why would you do this to yourself
	
	if P_IsObjectOnGround(player.mo) 
		player.starnum = 0 
		player.upfireboost = false
		player.firefuel = 40
	end
	
	--a cooldown?? at THIS hour??
	if player.starcooldown == nil then player.starcooldown = 0 end
	if player.starcooldown > 0
		player.starcooldown = $-1
		player.starcharger = 0
	end
	if player.powers[pw_carry] then player.starnum = 0 end
	
	local looker = P_LookForEnemies(player, false, false)
	if looker != nil and (player.powers[pw_shield] & SH_NOSTACK) == SH_ATTRACT
		P_SpawnLockOn(player, looker, S_LOCKON1)
	end
	
	//it is friday, in california. SHOOT
	if player.starcharger > 0 and not (player.cmd.buttons & BT_SPIN) and player.mo.state != S_HUGGERTFLY and player.starcooldown == 0 and player.mo.health and not (player.pflags & PF_THOKKED) and not (player.pflags & PF_FULLSTASIS) and not (CBW_Battle and CBW_Battle.PreRoundWait()) and not player.powers[pw_carry] and not (player.pflags & PF_SPINNING)
		if (CBW_Battle and player.guard != 0) return end
		if (CBW_Battle and player.actionstate != 0) return end
		if (not CBW_Battle and (player.powers[pw_shield] & SH_NOSTACK) == SH_FLAMEAURA) return end
		player.mo.color = player.skincolor
		player.mo.colorized = false
		if player.powers[pw_super] then player.starnum = 0 end
		
		if not (player.aimdown)
			player.starffset = 20*player.mo.scale
		else player.starffset = 10*player.mo.scale end
		
		local b = P_SpawnMobjFromMobj(player.mo, 0,0, player.starffset, MT_HUGGERTBULLET) -- the thing!!

		if not player.starchargeready -- determine type of bullet
			b.fullchargestar = false
		else 
			b.fullchargestar = true 
			b.state = S_HUGSTARNORMAL
		end
		
		b.target = player.mo
		b.angle = player.mo.angle
		if CBW_Battle and CBW_Battle.BattleGametype()
			b.hugshield = 0
			b.color = player.mo.color
		else
			b.color = ColorOpposite(player.mo.color)
			if player.jaspermode then b.color = SKINCOLOR_RED end
			b.hugshield = player.powers[pw_shield]
			if b.hugshield == 2049 then b.fuse = 5*TICRATE end
		end
		
		if b.hugshield == 4097
			b.tracer = looker
		end
		
		if player.starchargeready -- object size shenanigans
			b.radius = 17*player.mo.scale
			b.height = 32*player.mo.scale
			b.scale = player.mo.scale + (player.mo.scale/2)
			if player.jaspermode then b.state = S_HUGSTARNORMAL3 end
			b.starsped = 28*player.mo.scale+(player.speed/2)
		else
			b.scale = player.mo.scale + (player.mo.scale/3)
			if player.jaspermode then b.state = S_HUGGERTBULLET3 end
			b.starsped = 20*player.mo.scale+(player.speed/2)
			b.spriteyoffset = $ + 6*b.scale
		end
		
		if (player.aimdown)
			player.pflags = $1 & ~PF_STARTJUMP 
			if player.starchargeready	
				P_SetObjectMomZ(b, -22*FRACUNIT)
				if player.starnum < 5 then P_SetObjectMomZ(player.mo, (15*FRACUNIT - player.starnum*FRACUNIT)) end
			else
				P_SetObjectMomZ(b, -16*FRACUNIT)
				if player.starnum < 5  then P_SetObjectMomZ(player.mo, (9*FRACUNIT - player.starnum*FRACUNIT)) end
			end
			
			if player.isxmomentum
				P_SetObjectMomZ(player.mo, (player.speed/8), true)
			end	
				
			if not (CBW_Battle and CBW_Battle.BattleGametype())
				//wind and electric buff
				if b.hugshield == 2 or b.hugshield == 4098 then P_SetObjectMomZ(player.mo, (5*FRACUNIT), true) end
				if b.hugshield == 2
					S_StartSound(player.mo, sfx_wdjump)
				elseif b.hugshield == 4098
					S_StartSound(player.mo, sfx_s3k45)
				end
			end
			
			player.mo.state = S_PLAY_JUMP
			player.starnum = $+1
		else
			if player.starchargeready
				P_InstaThrust(b, b.angle, 28*player.mo.scale+(player.speed/2))
				if PSO
					local bulb = PSO.lib.spawnMissile(player.mo, MT_PSO_RIFLESHOT, player.mo.angle, 28*player.mo.scale+(player.speed/2), 100, DMT_RANGED, 24*cos(player.mo.angle), 24*sin(player.mo.angle), player.mo.scale*2)
					bulb.color = SKINCOLOR_FREEZERFOLLEY
					if multiplayer then bulb.color = ColorOpposite(player.mo.color) end
				end
			else
				P_InstaThrust(b, b.angle, 20*player.mo.scale+(player.speed/2))
				if PSO
					local bulb = PSO.lib.spawnMissile(player.mo, MT_PSO_RIFLESHOT, player.mo.angle, 20*player.mo.scale+(player.speed/2), 100, DMT_RANGED, 24*cos(player.mo.angle), 24*sin(player.mo.angle), player.mo.scale*2)
					bulb.color = SKINCOLOR_FREEZERFOLLEY
					if multiplayer then bulb.color = ColorOpposite(player.mo.color) end
				end
			end

			player.mo.state = S_HUGGERT_FIRE
		end
		
		if (player.powers[pw_shield] & SH_FORCE) and not (CBW_Battle and CBW_Battle.BattleGametype())
			b.hugshield = -1
			if player.starchargeready
				b.scale = ($*2) + 28
				b.momx = $*3/4 --the biggest goes the EXTRA slowest.
				b.momy = $*3/4
				b.momz = $*3/4
			else b.scale = $*2 end
			b.momx = $ *3/4
			b.momy = $ *3/4
			b.momz = $ *3/4
			b.spriteyoffset = $ - 6*b.scale
		end -- fuck this shield fr.......
		
		if player.starnum >= 5
			S_StartSound(player.mo, sfx_s1b6)
			P_SpawnMobjFromMobj(player.mo, 0,0,0, MT_FRANKSWET)
		end
		
		if player.jaspermode
			S_StartSound(player.mo, sfx_jspr)
		else
			if player.starchargeready 
				S_StartSound(player.mo, sfx_hgstb)
			else S_StartSound(player.mo, sfx_hgsth) end
		end
		player.starchargeready = false
		player.starcharger = 0
		player.starcooldown = TICRATE/2 
		if not (CBW_Battle and CBW_Battle.BattleGametype())
			if (player.powers[pw_shield] & SH_NOSTACK) == SH_BUBBLEWRAP
			or (player.powers[pw_shield] & SH_NOSTACK) == SH_ELEMENTAL
				player.starcooldown = 25
			end
			if (player.powers[pw_shield] & SH_FORCE) or (player.powers[pw_shield] & SH_NOSTACK) == SH_ARMAGEDDON then player.starcooldown = 38 end
		end
		
		if CBW_Battle and CBW_Battle.BattleGametype()
			b.fuse = 3*TICRATE 
			player.starcooldown = $ + 12
			player.speed = $*2/5
		end
		
	end
	
	//IS THAT A FUCKING FLAMETHROWER                    yes.
	if player.flamedist == nil or not (player.cmd.buttons & BT_SPIN)  
		player.flamedist = 15*player.mo.scale
	end
	if player.flameon == nil then player.flameon = false end
	
	if (player.powers[pw_shield] & SH_NOSTACK) == SH_FLAMEAURA
	and (player.cmd.buttons & BT_SPIN) and player.mo.state != S_HUGGERTFLY
	and not (P_PlayerInPain(player)) and player.playerstate == PST_LIVE
	and player.mo.health
	and not (player.mo.state == S_PLAY_ROLL or player.mo.state == S_PLAY_SPINDASH)
	and not player.powers[pw_carry]
	and not (player.pflags & PF_THOKKED)
	and not (player.pflags & PF_SPINNING)
	and not (player.pflags & PF_FULLSTASIS)
	and not (CBW_Battle and CBW_Battle.PreRoundWait())
	and not srb2p
	and not (CBW_Battle and CBW_Battle.BattleGametype())
		if (CBW_Battle and player.guard != 0) return end
		player.flameon = true
		if player.flamedist < 48*FRACUNIT and (leveltime % 6 == 0) and not CBW_Battle then player.flamedist = $ + FRACUNIT end
		player.drawangle = player.mo.angle
		player.normalspeed = (skins["huggert"].normalspeed)/2
		local b = P_SpawnMobjFromMobj(player.mo, P_ReturnThrustX(nil,player.mo.angle,FRACUNIT*5),P_ReturnThrustY(nil,player.mo.angle,FRACUNIT*5),10*player.mo.scale, MT_HUGGERTBULLET)
		b.color = SKINCOLOR_VOLCANIC
		b.target = player.mo
		b.angle = player.mo.angle + FixedAngle( P_RandomRange(-3, 3)*FRACUNIT)
		b.hugshield = 1025
		if player.jaspermode 
			b.color = SKINCOLOR_RED 
			b.state = S_HUGGERTBULLET3
		end
		b.fuse = TICRATE/2
		b.scale = $*3/4
		
		local flames = P_SpawnMobjFromMobj(player.mo, P_ReturnThrustX(nil,player.mo.angle,FRACUNIT*10),P_ReturnThrustY(nil,player.mo.angle,FRACUNIT*10),P_RandomRange(-5, 5)*player.mo.scale, MT_THOK)
		flames.state = S_SPINDUST_FIRE1
		flames.angle = player.mo.angle + FixedAngle( P_RandomRange(-5, 5)*FRACUNIT)

		if (leveltime % 2 == 0) 
			if player.jaspermode then S_StartSound(player.mo, sfx_jspr)
			else S_StartSound(player.mo, sfx_hugnit) end
		end
		
		if (player.aimdown) -- a wee bit of a hover to boot
			P_SetObjectMomZ(b, -1*player.flamedist)
			P_SetObjectMomZ(flames, -1*player.flamedist)
			P_InstaThrust(flames, flames.angle, P_RandomRange(-5, 5)*FRACUNIT)
			P_Thrust(flames, flames.angle+ ANGLE_90,P_RandomRange(-5, 5)*FRACUNIT)
			
			
			if not player.upfireboost and player.firefuel != 0
				player.firefuel = $-1
				if (player.mo.momz/P_MobjFlip(player.mo) >= 7*player.mo.scale)     
					P_SetObjectMomZ(player.mo, 7*FRACUNIT)
				else P_SetObjectMomZ(player.mo, 1*FRACUNIT, true) end
			else player.upfireboost = true end
			if player.upfireboost and (player.mo.momz/P_MobjFlip(player.mo) <= -2*player.mo.scale)
				P_SetObjectMomZ(player.mo, -2*FRACUNIT) 
			end
		else
			P_InstaThrust(b, b.angle, player.flamedist+(player.speed/2))
			flames.momz = P_RandomRange(0, 2)*player.mo.scale
			P_InstaThrust(flames, flames.angle, player.flamedist+(player.speed/2))
			if PSO
				local bulb = PSO.lib.spawnMissile(player.mo, MT_PSO_RIFLESHOT, player.mo.angle, 20*player.mo.scale+(player.speed/2), 100, DMT_RANGED, 24*cos(player.mo.angle), 24*sin(player.mo.angle), player.mo.scale*2)
				bulb.color = SKINCOLOR_FREEZERFOLLEY
				if multiplayer then bulb.color = ColorOpposite(player.mo.color) end
			end
		end
	end
	if player.flameon and not (player.cmd.buttons & BT_SPIN) -- disable the slowdown
	or player.flameon and not (player.powers[pw_shield] & SH_NOSTACK) == SH_FLAMEAURA
	or P_PlayerInPain(player) and player.flameon
		player.normalspeed = (skins["huggert"].normalspeed)
		player.flameon = false
	end
	
	// --------------------------------------- Hey wanna see some SQUARSHING
	if player.mariosquashed and player.mariosquashed > TICRATE - 1
		player.mariosquashed = TICRATE - 1
		S_StartSound(player.mo, sfx_dsqeak)
	end
	
	if player.croucher == nil
		player.croucher = false
		player.squasheffect = 0
	end
	
	if (player.cmd.buttons & BT_CUSTOM1) and not P_PlayerInPain(player)
	and player.mo.state != S_HUGGERTFLY
	and not (player.powers[pw_carry] == CR_NIGHTSMODE)
	and not (player.pflags & PF_SPINNING)
		if (CBW_Battle and player.tumble)
		or (CBW_Battle and player.airdodge)
		or CBW_Battle and CBW_Battle.PreRoundWait() 
		or CBW_Battle and player.actionstate != 0 return end
		player.normalspeed = (skins["huggert"].normalspeed)/2
		player.croucher = true
		player.starchargeready = false
		if player.starcooldown <= 2 then player.starcooldown = 2 end
		player.clouddown = 2
		if player.squasheffect != 3 then player.squasheffect = $+1 end
		if (player.mo.eflags & MFE_SPRUNG)
		and P_IsObjectOnGround(player.mo)
			player.mo.state = S_PLAY_ROLL
			S_StartSound(player.mo, sfx_spin)
			player.pflags = $|PF_SPINNING
			player.height = skins[player.mo.skin].height
		end
		
		if player.squasheffect == 1
			player.mo.spritexscale = (FRACUNIT*4/3)
			player.mo.spriteyscale = (FRACUNIT*6/10)
			player.mo.colorized = false
			S_StartSound(player.mo, sfx_hsqsh)
		elseif player.squasheffect == 3
			player.mo.spritexscale = (FRACUNIT*13/10)
			player.mo.spriteyscale = (FRACUNIT*7/10)
		end
	end
	
	if player.croucher and not (player.cmd.buttons & BT_CUSTOM1) --unsquish
	or P_PlayerInPain(player)
	or (player.pflags & PF_SPINNING)
		player.croucher = false
		player.normalspeed = (skins["huggert"].normalspeed)
		player.squasheffect = 0
		player.mo.spritexscale = FRACUNIT
		player.mo.spriteyscale = FRACUNIT
	end


	if player.powers[pw_carry] == CR_GENERIC
		player.mo.colorized = false
		player.starchargeready = false
		if player.starcooldown <= 2 then player.starcooldown = 2 end
		player.clouddown = 2
		player.starnum = 5
	end
	
	if player.scorepenalty then
		--player blasted themselves
		local penalty = (player.playerstate == PST_LIVE) and 50 or 100 --because killing gives more points than hitting
		player.score = max(0,$-penalty)
		if player.preservescore then player.preservescore = max(0,$-penalty) end
		--for arena
		if player.ctfteam == 1 then redscore = max(0,$-penalty) end
		if player.ctfteam == 2 then bluescore = max(0,$-penalty) end
		player.scorepenalty = false
	end
	
end)

addHook("MobjSpawn", function(mo)	
	if mo.valid
		mo.hit_sound = sfx_hit04
		mo.blockable = 1
		mo.block_stun = 5
		mo.block_hthrust = 12
		mo.block_vthrust = 10
		mo.spawnfire = true
	end
end, MT_HUGGERTBULLET)

local function HuggertHeight(p)
	if (p.mo and p.mo.valid and p.mo.skin == "huggert") and p.croucher then return P_GetPlayerSpinHeight(p) end
end
addHook("PlayerHeight", HuggertHeight)
addHook("PlayerCanEnterSpinGaps", HuggertHeight)

addHook("MobjThinker", function(starsm)
	if (starsm) and starsm.valid
		if starsm.fadetime == nil then starsm.fadetime = 15 end
		starsm.fadetime = $-1
		if starsm.target and (starsm.target.player.starcharger > 4)
			starsm.info.speed = (R_PointToDist2(starsm.x, starsm.y, starsm.target.x, starsm.target.y)/7)
			P_HomingAttack(starsm, starsm.target)
		end
		
		if starsm.fadetime == 5
			starsm.frame = $|TR_TRANS20
		elseif starsm.fadetime == 4
			starsm.frame = $|TR_TRANS40
		elseif starsm.fadetime == 3
			starsm.frame = $|TR_TRANS60
		elseif starsm.fadetime == 2
			starsm.frame = $|TR_TRANS80
		elseif starsm.fadetime == 1
			starsm.frame = $|TR_TRANS90
		end
	end
end, MT_HUGGERTSSTARPART)

addHook("MobjThinker", function(starsm)
	local payer = starsm.target.player
	if (starsm) and starsm.valid 
		if starsm.fullchargestar
			if starsm.state == S_HUGSTARBIG1 or starsm.state == S_HUGSTARBIG2
				starsm.rollangle = $ + FixedAngle(4*FRACUNIT)
			else starsm.rollangle = $ + FixedAngle(15*FRACUNIT) end
			P_CheckAndCrumble(starsm)
			starsm.name = "Shooting Star"
			starsm.blockable = 1
			starsm.block_stun = 8
			starsm.block_hthrust = 22
			starsm.block_vthrust = 14
		else 
			starsm.rollangle = $ + FixedAngle(9*FRACUNIT)
			starsm.name = "Star Bullet"
		end
		
		if (leveltime % 2 == 0) and not (payer.jaspermode) and not (starsm.state == S_HUGSTARP3 or starsm.state == S_HUGSTARP4 or starsm.state == S_HUGSTARP5)
			local st = P_SpawnMobj(starsm.x+(P_RandomRange(-7, 7)*starsm.scale), starsm.y+(P_RandomRange(-7, 7)*starsm.scale), starsm.z+(P_RandomRange(-7, 14)*starsm.scale), MT_HUGGERTSSTARPART)
			st.scale = starsm.scale*(P_RandomRange(2, 3)/2)
			st.color = starsm.color
			if P_RandomRange(0, 1) == 1
				st.momx = starsm.momx + P_RandomRange(-2, 1)*FRACUNIT
				st.momy = starsm.momy + P_RandomRange(-2, 1)*FRACUNIT
			else
				st.momx = (starsm.momx/2) + P_RandomRange(-2, 1)*FRACUNIT
				st.momy = (starsm.momy/2) + P_RandomRange(-2, 1)*FRACUNIT
			end
			st.momz = starsm.momz + P_RandomRange(-2, 1)*FRACUNIT
		end 
		
		if CBW_Battle and CBW_Battle.BattleGametype() and not (P_IsObjectOnGround(starsm)) then starsm.flags = $|MF_MISSILE end
		
		-- shield FX
		if not (CBW_Battle and CBW_Battle.BattleGametype())
			if starsm.hugshield == 2049 -- bubble
				starsm.color = SKINCOLOR_ARCTIC
				starsm.flags = $1|MF_BOUNCE|MF_GRENADEBOUNCE
				
				local elec = P_SpawnMobjFromMobj(starsm, 0,0,0, MT_PARTICLE)
				elec.scale = $*3/4
				elec.fuse = 2
				elec.sprite = SPR_BUBS
				elec.frame = K
				elec.momx = starsm.momx
				elec.momy = starsm.momy
				elec.momz = starsm.momz
				
				local b = P_SpawnMobjFromMobj(starsm, (P_RandomRange(-15,15)*starsm.scale),(P_RandomRange(-15,15)*starsm.scale),(P_RandomRange(-15,15)*starsm.scale), MT_PARTICLE)
				b.fuse = 20
				b.state = S_MEDIUMBUBBLE
				b.momx = (starsm.momx + (P_RandomRange(-5,5)*starsm.scale))/2
				b.momy = (starsm.momy + (P_RandomRange(-5,5)*starsm.scale))/2
				b.momz = (starsm.momz + (P_RandomRange(-5,5)*starsm.scale))/2
				b.destscale = 0
				b.scalespeed = FRACUNIT/12
				
				if starsm.fuse == 4 then S_StartSound(starsm, sfx_s3k77) end
			-- elemental
			elseif starsm.hugshield == 3073 and not (starsm.state == S_HUGSTARP3 or starsm.state == S_HUGSTARP4 or starsm.state == S_HUGSTARP5)
				starsm.color = SKINCOLOR_EVENTIDE
				
				local elec = P_SpawnMobjFromMobj(starsm, 0,0,0, MT_PARTICLE)
				elec.scale = $*3/4
				elec.fuse = 2
				elec.sprite = SPR_BUBS
				elec.frame = K
				elec.momx = starsm.momx
				elec.momy = starsm.momy
				elec.momz = starsm.momz
				
				local b = P_SpawnMobjFromMobj(starsm, (P_RandomRange(-15,15)*starsm.scale),(P_RandomRange(-15,15)*starsm.scale),(P_RandomRange(-15,15)*starsm.scale), MT_PARTICLE)
				b.fuse = 20
				b.state = S_MEDIUMBUBBLE
				b.momx = (starsm.momx + (P_RandomRange(-5,5)*starsm.scale))/2
				b.momy = (starsm.momy + (P_RandomRange(-5,5)*starsm.scale))/2
				b.momz = (starsm.momz + (P_RandomRange(-5,5)*starsm.scale))/2
				b.destscale = 0
				b.scalespeed = FRACUNIT/12

				if (leveltime % 3 == 0)
					local fi = P_SpawnMobjFromMobj(starsm, P_RandomRange(-10,10)*starsm.scale,P_RandomRange(-10,10)*starsm.scale,P_RandomRange(-5,4)*starsm.scale, MT_DUMFIRE)
					fi.target = starsm.target
					fi.fuse = TICRATE
					if starsm.fullchargestar then fi.fuse = 2*TICRATE end
					if CBW_Battle then fi.fuse = $/2 end
					fi.spriteyscale = $/2
					fi.height = 25*FRACUNIT
					fi.blendmode = AST_ADD
					if G_RingSlingerGametype() or CBW_Battle or not (gametyperules & (GTR_FRIENDLY))
						fi.color = starsm.color 
						fi.colorized = true
					end
					
					local pfire = P_SpawnMobj(starsm.x + (P_RandomRange(-15,15)*starsm.scale),starsm.y + (P_RandomRange(-15,15)*starsm.scale),starsm.z + (P_RandomRange(-3,18)*starsm.scale),MT_FLAMEPARTICLE)
					pfire.momx = starsm.momx
					pfire.momy = starsm.momy
				end
			--Break walls, why not? (Flame)
			elseif starsm.hugshield == 1025 and (leveltime % 3 == 0) 
				P_CheckAndCrumble(starsm)
				local pfire = P_SpawnMobj(starsm.x + (P_RandomRange(-32,32)*starsm.scale),starsm.y + (P_RandomRange(-32,32)*starsm.scale),starsm.z + (P_RandomRange(-3,32)*starsm.scale),MT_FLAMEPARTICLE)
				pfire.momx = starsm.momx
				pfire.momy = starsm.momy
				pfire.fuse = starsm.fuse
				if S_SoundPlaying(starsm, sfx_hgspf) then S_StopSoundByID(starsm, sfx_hgspf) end
			-- Force
			elseif starsm.hugshield == -1 
				local meteor = P_SpawnMobjFromMobj(starsm, 0,0,0, MT_HUGMETEOR)
				meteor.meatiorized = true --see because it doesnt get more meatier than this get it do you get thhe joke
				meteor.target = starsm.target
				meteor.tracer = starsm
				meteor.scale = $/2
				meteor.color = ColorOpposite(starsm.color)
				if starsm.fullchargestar
					local meteor = P_SpawnMobjFromMobj(starsm, 0,0,0, MT_HUGMETEOR)
					meteor.meatiorized = true --see because it doesnt get more meatier than this get it do you get thhe joke
					meteor.target = starsm.target
					meteor.tracer = starsm
					meteor.scale = $/2
					meteor.color = starsm.color
					meteor.otherside = true
					starsm.spritexscale = $ - 45
					starsm.spriteyscale = $ - 45
					starsm.state = S_HUGSTARBIG1
				else starsm.state = S_HUGSTARNORMAL end
				starsm.color = SKINCOLOR_GALAXY
				starsm.hugshield = -2
			elseif starsm.hugshield == -2 and not (starsm.state == S_HUGSTARP3 or starsm.state == S_HUGSTARP4 or starsm.state == S_HUGSTARP5)
				starsm.angle = $ + FixedAngle(8*FRACUNIT)
				P_CheckAndCrumble(starsm)
				for i = 0, 2
					local sparkstrail = P_SpawnMobjFromMobj(starsm, P_RandomRange(-25, 25)*starsm.scale,P_RandomRange(-25, 25)*starsm.scale, P_RandomRange(-8, 25)*starsm.scale, MT_BOXSPARKLE)
					sparkstrail.scale = $*(1/P_RandomRange(1, 3))
					sparkstrail.color = starsm.color
					sparkstrail.colorized = true
					sparkstrail.momx = (P_RandomRange(-1, 1)*starsm.scale)/2
					sparkstrail.momy = (P_RandomRange(-1, 1)*starsm.scale)/2
					sparkstrail.destscale = 0
					sparkstrail.scalespeed = starsm.scale/12
					sparkstrail.fuse = TICRATE/2
					sparkstrail.frame = $|FF_FULLBRIGHT
				end
			-- Attraction
			elseif starsm.hugshield == 4097 and not (starsm.state == S_HUGSTARP3 or starsm.state == S_HUGSTARP4 or starsm.state == S_HUGSTARP5)
				starsm.color = SKINCOLOR_GOLDENROD
				local elec = P_SpawnMobjFromMobj(starsm, 0,0,0, MT_PARTICLE)
				elec.scale = $/2
				elec.fuse = 3
				elec.color = SKINCOLOR_YELLOW
				elec.colorized = true
				elec.spritexscale = $ + 1*elec.scale
				elec.spriteyoffset = -18*elec.scale
				elec.sprite = SPR_ELEC
				elec.frame = P_RandomRange(0,11)
				elec.momx = starsm.momx
				elec.momy = starsm.momy
				elec.momz = starsm.momz
				if starsm.tracer == nil then return end
				A_HomingChase(starsm, starsm.starsped, 1)
			-- Wind FX
			elseif starsm.hugshield == 2 and not (starsm.state == S_HUGSTARP3 or starsm.state == S_HUGSTARP4 or starsm.state == S_HUGSTARP5)
				starsm.color = SKINCOLOR_MINT
				local gost = P_SpawnGhostMobj(starsm)
				gost.destscale = 0
				gost.scalespeed = FRACUNIT/18
				for i = 0,2
					if leveltime % 2 != 0 return end
					local clod = P_SpawnMobjFromMobj(starsm, P_RandomRange(-15,15)*starsm.scale,P_RandomRange(-15,15)*starsm.scale,P_RandomRange(0,30)*starsm.scale, MT_HGTCLOUDS)
					clod.scale = $/3
					clod.color = SKINCOLOR_SUPERSILVER2     
					clod.colorized = true
					clod.momx = starsm.momx + P_RandomRange(-2,2)*starsm.scale
					clod.momy = starsm.momy + P_RandomRange(-2,2)*starsm.scale
					clod.momz = starsm.momz + P_RandomRange(-2,2)*starsm.scale
					clod.destscale = 0
					clod.scalespeed = FRACUNIT/16
				end
				
				if starsm.widtim == nil or starsm.widtim == 7 then starsm.widtim = 0 end
				if starsm.widtim == 0
					local elec = P_SpawnMobjFromMobj(starsm, 0,0,0, MT_PARTICLE)
					elec.scale = $*3/4
					elec.fuse = 15
					elec.state = S_WIND1
					elec.target = starsm
					elec.momx = starsm.momx
					elec.momy = starsm.momy
					elec.momz = starsm.momz
				end
				starsm.widtim = $+1
			-- Electric FX
			elseif starsm.hugshield == 4098 and not (starsm.state == S_HUGSTARP3 or starsm.state == S_HUGSTARP4 or starsm.state == S_HUGSTARP5)
				starsm.color = SKINCOLOR_AETHER
				local elec = P_SpawnMobjFromMobj(starsm, 0,0,0, MT_THOK)
				elec.scale = $/2
				elec.fuse = 8
				elec.spritexscale = $ + 1*elec.scale
				elec.spriteyoffset = -18*elec.scale
				elec.sprite = SPR_ELEC
				elec.frame = P_RandomRange(0,11)
				elec.momx = starsm.momx
				elec.momy = starsm.momy
				elec.momz = starsm.momz
			-- bobm fx
			elseif starsm.hugshield == 3
				if starsm.bobtim == nil or starsm.bobtim == 33 then starsm.bobtim = 1 end
				if starsm.bobtim == 1
					for i = 0, 1
						local elec = P_SpawnMobjFromMobj(starsm, 0,0,0, MT_PARTICLE)
						elec.scale = $*3/4
						elec.fuse = 32
						elec.state = S_ARMF1
						elec.target = starsm
						if i == 1 then elec.state = S_ARMB1 end
						elec.momx = starsm.momx
						elec.momy = starsm.momy
						elec.momz = starsm.momz
					end
				end
				starsm.bobtim = $+1
			end
			
			if starsm.justbombed == nil then starsm.justbombed = false end
			if starsm.hugshield == 3 then starsm.color = SKINCOLOR_SANGRIA end
			if starsm.hugshield == 3 and starsm.state == S_HUGSTARP1 and not starsm.justbombed -- armageddon
				starsm.justbombed = true
				if starsm.fullchargestar
					FavExploder(starsm, 150*starsm.scale, nil, false, true)
					S_StartSound(starsm, sfx_bexpld)
				else
					FavExploder(starsm, 100*starsm.scale, nil, false, true)
					S_StartSound(starsm, sfx_s3kb4)
				end
				
				local bom = P_SpawnMobjFromMobj(starsm, 0, 0, 0, MT_THOK)
				bom.sprite = SPR_BARX
				bom.frame = B
				bom.scale = $/4
				bom.destscale = $*2
				bom.scalespeed = FRACUNIT/19
				for i = 1, 6
					local d = P_SpawnMobjFromMobj(starsm, 0,0,0, MT_HGTCLOUDS)
					d.scale = $*(3/2)
					d.color = SKINCOLOR_SILVER
					d.colorized = true
					d.angle = i*ANG60 + starsm.angle
					P_Thrust(d, d.angle, 5*starsm.scale)
					if starsm.fullchargestar then P_Thrust(d, d.angle, 7*starsm.scale) end
					d.destscale = $/5
					d.scalespeed = starsm.scale/40
					P_SetObjectMomZ(d, 2*FRACUNIT)
				end
				local bottom = P_SpawnMobjFromMobj(starsm, 0, 0, -7*starsm.scale, MT_HPARTICLES2)
				bottom.renderflags = $ | RF_FLOORSPRITE
				bottom.color = starsm.color
				bottom.frame = $|FF_FULLBRIGHT
				
				if starsm.fullchargestar
					bottom.destscale = $*28 
				else bottom.destscale = $*18 end
				bottom.scalespeed = FRACUNIT/2
				-- let me have my fun shut up
				if P_RandomRange(0, 200) == 1 and payer.favfunnytoggle == 1
					S_StartSound(starsm, sfx_faddie)
					P_SpawnMobjFromMobj(starsm, 0,0,0, MT_FADBOOM)
				end
			end
		end
		if starsm.dreamstar == true
			if not (starsm.state == S_HUGSTARP1 or starsm.state == S_HUGSTARP2 or starsm.state == S_HUGSTARP3 or starsm.state == S_HUGSTARP4 or starsm.state == S_HUGSTARP5) then starsm.state = S_HUGSTARBIG1 end
			for i = 0, 2
				local sparkstrail = P_SpawnMobjFromMobj(starsm, P_RandomRange(-25, 25)*starsm.scale,P_RandomRange(-25, 25)*starsm.scale, P_RandomRange(-8, 25)*starsm.scale, MT_BOXSPARKLE)
				sparkstrail.scale = $*(1/P_RandomRange(1, 3))
				sparkstrail.color = starsm.color
				sparkstrail.colorized = true
				sparkstrail.momx = (P_RandomRange(-1, 1)*starsm.scale)/2
				sparkstrail.momy = (P_RandomRange(-1, 1)*starsm.scale)/2
				sparkstrail.destscale = 0
				sparkstrail.scalespeed = starsm.scale/12
				sparkstrail.fuse = TICRATE/2
				sparkstrail.frame = $|FF_FULLBRIGHT
			end
			
			if starsm.state == S_HUGSTARP1 or starsm.fuse == 1
				for i = 1,12 
					local mf = P_SpawnMobjFromMobj(starsm, 0,0,10*starsm.scale, MT_HUGGERTBULLET)
					mf.angle = starsm.angle+(ANG30*i)
					if mf and mf.valid
						mf.fuse = TICRATE
						mf.scale = $/2
						mf.target = starsm.target
						P_InstaThrust(mf,mf.angle,5*FRACUNIT)
						mf.frame = FF_FULLBRIGHT|FF_TRANS70
						mf.blendmode = AST_ADD
						mf.color = starsm.color
					end
					
					local st = P_SpawnMobj(starsm.x+(P_RandomRange(-7, 7)*starsm.scale), starsm.y+(P_RandomRange(-7, 7)*starsm.scale), starsm.z+(P_RandomRange(-7, 14)*starsm.scale), MT_HUGGERTSSTARPART)
					st.scale = starsm.scale*(P_RandomRange(2, 3)/2)
					st.color = starsm.color
					st.momx = P_RandomRange(-12, 12)*starsm.scale
					st.momy = P_RandomRange(-12, 12)*starsm.scale
					st.momz = P_RandomRange(-12, 12)*starsm.scale
				end
				
				local mf = P_SpawnMobjFromMobj(starsm, 0,0,0, MT_THOK)
				mf.color = starsm.color
				mf.destscale = $*18
				mf.scalespeed = FRACUNIT/14
				mf.fuse = TICRATE/2
				starsm.state = S_HUGSTARP2
				S_StartSound(starsm, sfx_kc6d)
				S_StartSound(starsm, sfx_cdfm14)
				S_StartSound(starsm, sfx_s3kb8)
				starsm.dreamstar = false -- that way the explosion can only happen ONCE
			end
			
		end
	end
	
	if leveltime % 2 == 0 and starsm.valid and not (starsm.target.player.jaspermode) and not (starsm.state == S_HUGSTARP1 or starsm.state == S_HUGSTARP2 or starsm.state == S_HUGSTARP3 or starsm.state == S_HUGSTARP4 or starsm.state == S_HUGSTARP5)
	and not (starsm.momx == 0 and starsm.momy == 0 and starsm.momz == 0)
	and starsm.hugshield == 0
		if starsm.dreamstar return end
		local fir = P_SpawnMobjFromMobj(starsm, 0,0,0, MT_HGTFLY)
		fir.target = starsm
		fir.sprite = SPR_HTHK
		fir.scale = $*(9/5)
		if starsm.momz*P_MobjFlip(starsm) > 0
			fir.frame = C
		elseif starsm.momz*P_MobjFlip(starsm) < 0
			fir.frame = B
		else fir.frame = A end
		fir.frame = $|TR_TRANS50|FF_FULLBRIGHT
		fir.momx = starsm.momx
		fir.momy = starsm.momy
		fir.momz = starsm.momz
		fir.angle = starsm.angle
		fir.color = starsm.color
		fir.fuse = 2
	end	
	
	if (payer.jaspermode) then P_SpawnGhostMobj(starsm) end
end, MT_HUGGERTBULLET)

addHook("TouchSpecial", function(star, mo) //NO interactions thanks
	if mo and mo.valid and mo.player 
	and star and star.valid
	and star.target.player.ctfteam == mo.player.ctfteam
		return true
	end
end, MT_HUGGERTBULLET)

addHook("MobjThinker", function(thebox)
	if thebox.tracer 
	and thebox.tracer.valid 
	and (thebox.meatiorized) 
	and not (thebox.tracer.state == S_HUGSTARP3 or thebox.tracer.state == S_HUGSTARP4 or thebox.tracer.state == S_HUGSTARP5)
		if thebox.otherside
			P_MoveOrigin(thebox, thebox.tracer.x+P_ReturnThrustX(nil,thebox.tracer.angle,FRACUNIT*-75), thebox.tracer.y+P_ReturnThrustY(nil,thebox.tracer.angle,FRACUNIT*-75), thebox.tracer.z)
		else P_MoveOrigin(thebox, thebox.tracer.x+P_ReturnThrustX(nil,thebox.tracer.angle,FRACUNIT*75), thebox.tracer.y+P_ReturnThrustY(nil,thebox.tracer.angle,FRACUNIT*75), thebox.tracer.z) end
		thebox.rollangle = $ + FixedAngle(10*FRACUNIT)
	else
		pcall(P_RemoveMobj, thebox)
	end
end, MT_HUGMETEOR)

addHook("MobjThinker", function(thebox)
	if thebox.target 
	and thebox.target.valid 
	and (thebox.target.state == S_HUGSTARP1 or thebox.target.state == S_HUGSTARP2 or thebox.target.state == S_HUGSTARP3 or thebox.target.state == S_HUGSTARP4 or thebox.target.state == S_HUGSTARP5) -- only the star projectile can use these so we good
		pcall(P_RemoveMobj, thebox)
	end
end, MT_PARTICLE)


addHook("MobjMoveCollide", function(star, meanie)
	-- hey lets just burn through players so they dont block shit
	if not ((star) and (star.valid) and (meanie.valid)) return end
	
	if not (star.fullchargestar)
		if(star.z <= meanie.z + meanie.height)
		and(star.z + star.height >= meanie.z)
		and ( (meanie.valid and meanie.player and meanie.health) 
		or (meanie.flags & MF_ENEMY) and not (meanie.flags & MF_BOSS))
		
			if not (meanie.valid and meanie.player) and (star.hugshield == -1 or star.hugshield == -2) then P_DamageMobj(meanie, star, star.target) end
			
			if (star.hugshield == 2 or star.hugshield == 4098) --wind or electric
			and meanie != star.target
			and not (CBW_Battle and CBW_Battle.BattleGametype())
				if (meanie.flags & MF_ENEMY) and meanie.health <= 1 return end
				if meanie.player and meanie.player.hugshields != 0 return end
				P_SetObjectMomZ(meanie, 9*FRACUNIT, false)
				
				for i = 1,12
					local fa = (i*ANG30)
					local mo = P_SpawnMobjFromMobj(meanie, 0,0,0, MT_HUGGERTSSTARPART)
					mo.color = meanie.color
					if star.hugshield == 4098 then mo.color = SKINCOLOR_BONE end
					mo.blendmode = AST_ADD
					mo.scale = $*2
					if mo and mo.valid
						mo.momy = FixedMul(cos(fa), 4*meanie.scale)
						mo.momx = FixedMul(sin(fa), 4*meanie.scale)
						mo.momz = 2*meanie.scale*P_MobjFlip(meanie)
					end
					mo.destscale = 0
					mo.scalespeed = FRACUNIT/15
					i = $+1
				end
				
				local ghost = P_SpawnGhostMobj(meanie)
					ghost.destscale = $*(4/3)
					ghost.scalespeed = FRACUNIT/15
					ghost.colorized = true
				if star.hugshield == 2
					S_StartSound(star, sfx_wdjump)
					ghost.color = SKINCOLOR_MINT
				else
					S_StartSound(star, sfx_s3k45)
					ghost.color = SKINCOLOR_BONE
				end
				if meanie.player
					meanie.player.mo.state = S_PLAY_ROLL
					meanie.player.pflags = $|PF_JUMPED
					meanie.player.pflags = $1 & ~PF_THOKKED
					meanie.player.pflags = $1 & ~PF_SPINNING
					meanie.player.hugshields = TICRATE/2
				end
			end
				
			if star.hugshield == 3073 and meanie != star.target and not (CBW_Battle and CBW_Battle.BattleGametype())
				if meanie.player and not (G_RingSlingerGametype() or CBW_Battle or not (gametyperules & (GTR_FRIENDLY))) return end
				for i = 1,12 
					local mf = P_SpawnMobjFromMobj(star, 0,0,0, MT_DUMFIRE)
					mf.angle = star.angle+(ANG30*i)
					if mf and mf.valid
						mf.fuse = TICRATE
						mf.scale = $/2
						mf.target = star.target
						P_InstaThrust(mf,mf.angle,5*FRACUNIT)
						mf.frame = FF_FULLBRIGHT|FF_TRANS70
						mf.blendmode = AST_ADD
						mf.colorized = false
						if G_RingSlingerGametype() or CBW_Battle or not (gametyperules & (GTR_FRIENDLY))
							mf.color = meanie.color 
							mf.colorized = true
						end
					end
				end
			end	
			
			if meanie.valid and (meanie.player and not G_RingSlingerGametype() and not CBW_Battle)
			or meanie.valid and (meanie.type == MT_SPIKE or meanie.type == MT_WALLSPIKE) and (star.hugshield == -1 or star.hugshield == -2)
				if (meanie.type == MT_SPIKE or meanie.type == MT_WALLSPIKE)
					P_KillMobj(meanie, star, star, DMG_NUKE)
				end
				return false 
			end
		end
	else
		if(star.z <= meanie.z + meanie.height)
		and(star.z + star.height >= meanie.z)
		and ((meanie.flags & MF_SHOOTABLE) or meanie.flags & MF_ENEMY or meanie.type == MT_SPIKE or meanie.type == MT_WALLSPIKE or meanie.valid and meanie.player and meanie.health)
			
			if not (meanie.valid and meanie.player) 
				if CBW_Battle and CBW_Battle.BattleGametype() and meanie.player and star.target.player.ctfteam == meanie.player.ctfteam return end
				P_DamageMobj(meanie, star, star.target, cv_huggertchargedamage.value) 
			end
			
			//WIND OR ELEECTRIC SHIELD EFFECT
			if (star.hugshield == 2 or star.hugshield == 4098) 
			and (meanie.player or meanie.flags & MF_ENEMY)
			and meanie != star.target
			and not (CBW_Battle and CBW_Battle.BattleGametype())
				if (meanie.flags & MF_ENEMY) and meanie.health <= 1 return end
				P_SetObjectMomZ(meanie, 16*FRACUNIT, false)
				for i = 1,12
					local fa = (i*ANG30)
					local mo = P_SpawnMobjFromMobj(meanie, 0,0,0, MT_HUGGERTSSTARPART)
					mo.color = meanie.color
					if star.hugshield == 4098 then mo.color = SKINCOLOR_BONE end
					mo.blendmode = AST_ADD
					mo.scale = $*2
					if mo and mo.valid
						mo.momy = FixedMul(cos(fa), 4*meanie.scale)
						mo.momx = FixedMul(sin(fa), 4*meanie.scale)
						mo.momz = 2*meanie.scale*P_MobjFlip(meanie)
					end
					mo.destscale = 0
					mo.scalespeed = FRACUNIT/15
					i = $+1
				end
				
				local ghost = P_SpawnGhostMobj(meanie)
					ghost.destscale = $*(4/3)
					ghost.scalespeed = FRACUNIT/15
					ghost.colorized = true
				if star.hugshield == 2
					S_StartSound(meanie, sfx_wdjump)
					ghost.color = SKINCOLOR_MINT
				else
					S_StartSound(meanie, sfx_s3k45)
					ghost.color = SKINCOLOR_BONE
				end
				if meanie.player
					meanie.player.mo.state = S_PLAY_ROLL
					meanie.player.pflags = $|PF_JUMPED
					meanie.player.pflags = $1 & ~PF_THOKKED
					meanie.player.pflags = $1 & ~PF_SPINNING
					meanie.player.hugshields = TICRATE/2
				end
			end	
			if star.hugshield == 3073 and meanie != star.target and (meanie.player or meanie.flags & MF_ENEMY) and not (CBW_Battle and CBW_Battle.BattleGametype())
				if meanie.player and not (G_RingSlingerGametype() or CBW_Battle) return end
				for i = 1,12
					local mf = P_SpawnMobjFromMobj(star, 0,0,0, MT_DUMFIRE)
					mf.angle = star.angle+(ANG30*i)
					if mf and mf.valid
						mf.fuse = TICRATE
						mf.scale = $/2
						mf.target = star.target
						P_InstaThrust(mf,mf.angle,5*FRACUNIT)
						mf.frame = FF_FULLBRIGHT|FF_TRANS70
						mf.blendmode = AST_ADD
						mf.colorized = false
						if G_RingSlingerGametype() or CBW_Battle or not (gametyperules & (GTR_FRIENDLY))
							mf.color = meanie.color 
							mf.colorized = true
						end
					end
				end
			end	
			
			if meanie.valid and (meanie.player)
			or meanie.valid and (meanie.type == MT_SPIKE or meanie.type == MT_WALLSPIKE) 
				if CBW_Battle and CBW_Battle.BattleGametype() and meanie.player and star.target.player.ctfteam == meanie.player.ctfteam return end
				if (meanie.type == MT_SPIKE or meanie.type == MT_WALLSPIKE)
					P_KillMobj(meanie, star, star, DMG_NUKE)
				else
					P_DamageMobj(meanie, star, star.target, 1)
				end
				if meanie.player and meanie.player.guard == 2 or meanie.player.powers[pw_flashing] return end
				return false 
			end
		end
	end
end, MT_HUGGERTBULLET)


addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.hugshields == nil or P_IsObjectOnGround(player.mo) then player.hugshields = 0 end
		if player.hugshields != 0 then player.hugshields = $-1 end
	end
end)

addHook("TouchSpecial", function(bubble, mo)
	if (bubble.type == MT_SPIKE or bubble.type == MT_WALLSPIKE)
	and mo and mo.valid and (mo.fullchargestar or mo.hugshield == -1 or mo.hugshield == -2)
		return true
	end
end, MT_HUGGERTBULLET)

addHook("MobjCollide", function(mo, mobj)
	if mobj and mobj.valid and  mobj.type == MT_RALSEI_PROJECTILE
	and mo and mo.player and mo.skin == "huggert" and mo.state != S_PLAY_WAIT
		local sleep = P_SpawnMobjFromMobj(mo, 0,0, mo.info.height/2, MT_THOK)
		sleep.state = S_RALSEI_SLEEP
		sleep.spritexscale = FRACUNIT*2
		sleep.spriteyscale = sleep.spritexscale
		S_StartSound(mo, sfx_ralss6)
		
		mo.state = S_PLAY_WAIT
	end
end, MT_PLAYER)
		
// the FUCK is going on with fans man
addHook("ThinkFrame", do
    for player in players.iterate 
        if not (player.mo and player.mo.valid and player.mo.skin == "huggert") return end
        
        if player.powers[pw_carry] == CR_DUSTDEVIL
        and (player.mo.sprite2 == SPR2_PAIN or player.powers[pw_super])
        or P_PlayerTouchingSectorSpecial(player, 4, 5) and (player.mo.sprite2 == SPR2_FALL or player.powers[pw_super])
        or player.fanobj and (player.mo.sprite2 == SPR2_FALL or player.powers[pw_super])
            player.clouddown = -1
			player.hughovercheck = false
        end
    end
end)
addHook("MobjMoveCollide", function(thing, tmthing)
    if thing and thing.valid and thing.player and thing.skin == "huggert"
    and tmthing and tmthing.valid and tmthing.type == MT_FAN
    and tmthing.z - thing.z <= thing.health << FRACBITS
        thing.player.fanobj = true
    end
end, MT_PLAYER)

kirbyabilitytable["huggert"] = 15 -- :)

/*
local function HugStarGui(d, p, cam) //Star testing GUI!!! Specifically commented out in case if i need it again later.
	if not (p.mo and p.mo.valid and p.mo.skin == "huggert") return end
	d.drawString(160, 40, "Charge: " +p.starcharger, V_SNAPTOTOP|V_ALLOWLOWERCASE|V_PURPLEMAP|V_30TRANS, "center")
	if p.starcooldown != 0 then d.drawString(160, 50, "Cooldown: " + p.starcooldown, V_SNAPTOTOP|V_ALLOWLOWERCASE|V_PURPLEMAP|V_30TRANS, "center") end
	if (p.aimdown)
		d.drawString(160, 60, "Aiming Downward", V_SNAPTOTOP|V_ALLOWLOWERCASE|V_PURPLEMAP|V_30TRANS, "center")
	else
		d.drawString(160, 60, "Aiming Straight", V_SNAPTOTOP|V_ALLOWLOWERCASE|V_PURPLEMAP|V_30TRANS, "center")
	end
	if p.starchargeready and leveltime%2 == 0 then d.drawString(160, 30, "CHARGED", V_SNAPTOTOP|V_ALLOWLOWERCASE|V_PURPLEMAP|V_30TRANS, "center") end
end
hud.add(HugStarGui, "game")*/

COM_AddCommand("jaspermode", function(player)
	if player.jaspermode
		CONS_Printf(player, "Disabled Jasper Mode.")
		player.jaspermode = false
	else
		CONS_Printf(player, "Enabled Jasper Mode!")
		player.jaspermode = true
	end
end)